# slashdot.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check www.uid-zero.de
#
# well this is my first newsposting script for the international communinty  :)
# everytime when there is a new headline at  slashdot.org the script will  post
# the headline  plus the link  into the channel.  its also possible  to get the
# last x news from slashdot.org by public or message command.
#
# v1.0 - first public version
#
# sdstrigger            - standard is ".slashdot",  the command forces  the bot
#			  to post you the latest 'sdlimit' headlines
# sdlimit               - "" for unlimited news or just use a number
# sdnewspost            - 1 activates newsposting, 0 disables it
# sdchans               - the chans the tcl is active in, "" for all, or just a
#			  list like "#chan1 #chan2"
# sdnewspostlimit       - prevents flooding,  the  bot doenst post more  than x
#			  headlines if there are new ones
# issdhub         	- makes  the bot  act as news hub or not, check out the 
#			  leaf tcl @ domsen.org
# sdleafs               - the bots the leaf tcl is installed on, "" for none
#
####### config ######################

set sdtrigger ".slashdot"
set sdchans ""
set sdlimit "8"
set sdnewspostlimit "3"
set sdnewspost "1"
set issdhub "0"
set sdleafs ""

####### end of config #############

bind msg - $sdtrigger msg_sd
bind pub - $sdtrigger pub_sd
bind time - "?0 * * * *" sdcheck

proc sendsdnews { arg } {
global sdleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $sdleafs] [string tolower $bot]] != -1)} {
putbot $bot "slashdot: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc sdnews { target limit } {
if {[catch {set sock [socket slashdot.org 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /slashdot.xml HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: slashdot.org"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<title>" $bl] != -1} { set newsline [string range $bl 9 [shrink - 1 "</" 0 $bl]]}
if {[string first "<url>" $bl] != -1} { set link [string range $bl 7  [shrink - 1 </ 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc sdcheck {nick uhost hand chan arg} {
global sdchans sdnewspost issdhub sdnewspostlimit
set counter 0
if {$sdnewspost == 1 } {
putlog "slashdot: searching for news"
set sdlastnews "none"
if {[file exists sd.hdl]} {
set temp [open "sd.hdl" r]
set sdlastnews "[gets $temp]"
close $temp
}
set temp [open "sd.hdl" w+]
if {[catch {set sock [socket slashdot.org 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /slashdot.xml HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: slashdot.org"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<title>" $bl] != -1} { set newsline [string range $bl 9 [shrink - 1 "</" 0 $bl]]}
if {[string first "<url>" $bl] != -1} { set link [string range $bl 7  [shrink - 1 </ 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$sdlastnews == "none" } { putlog "slashdot: headlinefile created" ; return 0 }
set temp [open "sd.hdl" r]
while { [eof $temp] != 1 } {
set sdneunews [gets $temp]
if {($sdlastnews == $sdneunews) || ($counter == $sdnewspostlimit)} {close $temp; return 0 }
incr counter
if { $issdhub == "1" } { sendsdnews $sdneunews }
foreach chan [channels] {
if {$sdchans == "" } { putserv "privmsg $chan :(slashdot news) $sdneunews" }
if {$sdchans != "" } {
if {([lsearch -exact [string tolower $sdchans] [string tolower $chan]] != -1) || ($sdchans == "")} {putserv "privmsg $chan :(slashdot news) $sdneunews"}
}
}}}}


proc msg_sd { nick uhost hand arg } { global sdlimit ; sdnews $nick $sdlimit }
proc pub_sd { nick uhost hand chan arg } { global sdchans sdlimit ; if {([lsearch -exact [string tolower $sdchans] [string tolower $chan]] != -1) || ($sdchans == "")} { sdnews $nick $sdlimit }}


putlog "*** slashdot.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
